package com.prank.funny.pranks.pager;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Toast;

import androidx.activity.result.ActivityResultCallback;
import androidx.activity.result.ActivityResultLauncher;
import androidx.activity.result.contract.ActivityResultContracts;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.GridLayoutManager;

import com.prank.funny.pranks.adapter.AdLike;
import com.prank.funny.pranks.bean.Info;
import com.prank.funny.pranks.databinding.FragRecorderBinding;
import com.prank.funny.pranks.listener.RecordListener;
import com.prank.funny.pranks.max.MaxManager;
import com.prank.funny.pranks.max.onAdAfterAction;
import com.prank.funny.pranks.tools.Common;
import com.prank.funny.pranks.tools.DataBase;
import com.prank.funny.pranks.tools.ItemSpace;

import java.util.List;
import java.util.Map;


public class FragmentRecorder extends Fragment implements View.OnClickListener , RecordListener {

    private FragRecorderBinding binding;
    private AdLike adapter;
    private ActivityResultLauncher<String> requestRecordAudioLauncher;
    private ActivityResultLauncher<String> audioPickerLauncher;
    private ActivityResultLauncher<String[]> requestStorePermissionsLauncher;
    private PopImport popRecorder;
    public FragmentRecorder() {

    }

    public static FragmentRecorder newInstance() {
        FragmentRecorder fragment = new FragmentRecorder();
        Bundle args = new Bundle();

        fragment.setArguments(args);
        return fragment;
    }
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragRecorderBinding.inflate(getLayoutInflater());

        binding.menu.setOnClickListener(this);
        ItemSpace itemHelper = new ItemSpace(10, 10, 5);
        binding.recyclerImport.addItemDecoration(itemHelper);
        binding.recyclerImport.setLayoutManager(new GridLayoutManager(requireContext(), 2));
        List<Info> all = DataBase.getAllCustomization();
        updateUi(all);
        adapter = new AdLike(requireContext(), all,true);
        binding.recyclerImport.setAdapter(adapter);


        return binding.getRoot();
    }
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        requestRecordAudioLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestPermission(),
                isGranted -> {
                    if (isGranted) {
                        intentRecordAudio();
                    } else {
                        Toast.makeText(requireContext(), "Recording permission denied", Toast.LENGTH_SHORT).show();
                    }
                }
        );

        requestStorePermissionsLauncher = registerForActivityResult(
                new ActivityResultContracts.RequestMultiplePermissions(),
                new ActivityResultCallback<Map<String, Boolean>>() {
                    @Override
                    public void onActivityResult(Map<String, Boolean> result) {
                        Boolean isGranted = true;
                        for (Map.Entry<String, Boolean> entry : result.entrySet()) {
                            String permission = entry.getKey();
                            isGranted = entry.getValue();
                            if(!entry.getValue()){
                                isGranted = false;
                            }

                        }
                        if (isGranted) {
                            importAudio();
                        }else {
                            Toast.makeText(requireContext(),   " 权限被拒绝", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
        );
        audioPickerLauncher = registerForActivityResult(new ActivityResultContracts.GetContent(),
                new ActivityResultCallback<Uri>() {
                    @Override
                    public void onActivityResult(Uri uri) {
                        // Handle the returned Uri

                        if (uri != null) {
                            long duration = Common.getAudioDuration(requireContext(), uri);
                            Intent intent = new Intent(requireContext(), ActivitySavePrank.class);
                            intent.putExtra(ActivitySavePrank.KEY_Path, uri.toString());
                            intent.putExtra(ActivitySavePrank.KEY_Time, duration);
                            startActivity(intent);
                        }
                    }
                });
    }




    public void refresh() {
        if (adapter != null) {
            List<Info> all = DataBase.getAllCustomization();
            updateUi(all);
            adapter.updateData(all);
        }

    }

    private void updateUi(List<Info> all) {
        if (all.size() == 0) {
            binding.noImportHint.setVisibility(View.VISIBLE);
            binding.recyclerImport.setVisibility(View.GONE);
        } else {
            binding.noImportHint.setVisibility(View.GONE);
            binding.recyclerImport.setVisibility(View.VISIBLE);
        }
    }

    private void checkAndRequestAudioPermission() {
        if (ContextCompat.checkSelfPermission(requireContext(), Common.permission_record_audio)
                != PackageManager.PERMISSION_GRANTED) {
            requestRecordAudioLauncher.launch(Common.permission_record_audio);
        } else {
            intentRecordAudio();
        }
    }

    private void intentRecordAudio() {
        Intent intent = new Intent(requireContext(), ActivityRecorder.class);
        startActivity(intent);
    }

    @Override
    public void onClick(View v) {
         if(v.equals(binding.menu)){
             MaxManager.startShowMaxAd(requireActivity(), new onAdAfterAction() {
                 @Override
                 public void onAction() {
                     if (popRecorder == null) {
                         popRecorder = new PopImport(requireActivity(), FragmentRecorder.this);
                     }
                     popRecorder.showBottom(binding.menu);
                 }
             });

        }
    }



    private void importAudio() {
        Intent intent = new Intent(Intent.ACTION_GET_CONTENT);
        intent.setType("audio/*");
        audioPickerLauncher.launch("audio/*");

    }


    @Override
    public void onClickTimerListener(int type) {
        switch (type){
            case 0:
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.TIRAMISU) {
                    if (ContextCompat.checkSelfPermission(requireContext(), Common.permission_read_audio[0])
                            != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(Common.permission_read_audio);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_read_audio,
//                            ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                } else {
                    if (ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.WRITE_EXTERNAL_STORAGE)
                            != PackageManager.PERMISSION_GRANTED ||
                            ContextCompat.checkSelfPermission(requireContext(), Manifest.permission.READ_EXTERNAL_STORAGE)
                                    != PackageManager.PERMISSION_GRANTED) {
                        requestStorePermissionsLauncher.launch(Common.permission_store);
//                    ActivityCompat.requestPermissions(requireActivity(), ConstValues.permission_store, ConstValues.REQUEST_READ_STORAGE_PERMISSION);
                    } else {
                        importAudio();
                    }
                }
                break;
            case 1:
                checkAndRequestAudioPermission();
                break;
        }
    }
}